// (c) Drobotenko Anatoly
// http://drobotenko.com/

#ifndef _huge_dble
extern float  _huge_flt, _indefinite;
extern double _huge_dble;
unsigned long  ul_huge_flt=0x7F7FFFFF, ul_indefinite=0x7FC00000;
unsigned long  ul8_huge_dble[2]={0xFFFFFFFF,0x7FeFFFFF};
extern float  _huge_flt=(float&)ul_huge_flt, _indefinite=(float&)ul_indefinite;
extern double _huge_dble=(double&)ul8_huge_dble[0];

#endif
int gaus_ostatok;
double  gaus_minved,gaus_deter;

template <class M> void matvec(double _rez[], M matr,double  vec[])
 { int r,k;
   #define N (sizeof(*matr)/sizeof(**matr))
   double rez[N];
   for(r=0;r<N;r++)
   {  rez[r]=0;
      for(k=0;k<N;k++)
         rez[r]+=matr[r][k]*vec[k];
   }
   for(k=N;k--;)
      _rez[k]=rez[k];
   #undef N
 }

template <class M> void matmat(M c, M _a,M _b)
 {
    #define N (sizeof(*_a)/sizeof(**_a))
    double a[N][N],b[N][N];
    int j,k,j0;
    for(j=N;j--;) for(k=N;k--;)
      a[j][k]=_a[j][k],b[j][k]=_b[k][j];

    for(j=N;j--;) for(k=N;k--;)
    { long double v=0;
      for(j0=N;j0--;)
         v+=a[j][j0]*b[k][j0];
      c[j][k]=v;
    }
    #undef N
 }

template <class M> void gaus(double  r[],M  _m,double  _v[])
 {
   #define N (sizeof(*_m)/sizeof(**_m))
   double m[N][N],v[N];
   memcpy(m,_m,sizeof m); memcpy(v,_v,sizeof v);
   int num[N];
   int j,jj,k;
   for(j=N;j--;)
      num[j]=j;
   register float vmax,aa; int jmax,kmax;
   vmax=-1;
   double t;
   for(j=N;j--;) for(k=N;k--;)
      if(vmax<(t=fabs(m[j][k])))
        vmax=t,jmax=j,kmax=k;

   gaus_ostatok=N;
   gaus_minved=vmax; gaus_deter=vmax;
   if(vmax<1e-99)
     return;
   gaus_ostatok--;

   for(j=N;j--;)
      t=m[j][kmax],m[j][kmax]=m[j][0],m[j][0]=t;
   for(k=N;k--;)
      t=m[jmax][k],m[jmax][k]=m[0][k],m[0][k]=t;
   t=v[jmax],v[jmax]=v[0],v[0]=t;
   num[0]=kmax;num[kmax]=0;

   for(j=0;j<N-1;j++)
   {  vmax=-1;
      for(jj=j+1;jj<N;jj++)
      {  double t=m[jj][j]/m[j][j];
         for(k=j+1;k<N;k++)
            if(vmax<(aa=fabs(m[jj][k]-=m[j][k]*t)))
               vmax=aa,jmax=jj,kmax=k;
         v[jj]-=v[j]*t;
      }

      if(gaus_minved>vmax)
         gaus_minved=vmax;
      gaus_deter*=m[jmax][kmax];
      if(vmax<1e-99)
         return;
      gaus_ostatok--;

      for(jj=N;jj--;)
         t=m[jj][kmax],m[jj][kmax]=m[jj][j+1],m[jj][j+1]=t;
      for(jj=N;jj-->j;)
         t=m[jmax][jj],m[jmax][jj]=m[j+1][jj],m[j+1][jj]=t;
      t=v[j+1];v[j+1]=v[jmax];v[jmax]=t;
      jj=num[j+1];num[j+1]=num[kmax];num[kmax]=jj;
   }
   for(j=N;j--;)
   {  double s=v[j];
      for(k=j+1;k<N;k++)
         s-=m[j][k]*m[N-1][k];
      m[N-1][j]=s/m[j][j];
   }
   for(j=N;j--;)
      r[num[j]]=m[N-1][j];
   #undef N
 }

template <class M> void invers(M m)
 {
   #define N (sizeof(*m)/sizeof(**m))
   int j,k;   int rn[N],cn[N];
   for(j=N;j--;)
     rn[j]=cn[j]=j;
   gaus_minved=1e99;
   gaus_deter=1;
   for(gaus_ostatok=N;gaus_ostatok;gaus_ostatok--)
   {  int jved,kved; double vved=-1,t;
      for(j=N;j--;)
      {  if(~rn[j])
         for(k=N;k--;)
           if(~cn[k])
           if(vved<fabs(m[j][k]))
              vved=fabs(m[j][k]),jved=j,kved=k;
      }
      if(gaus_minved>vved)
         gaus_minved=vved;
      gaus_deter*=m[jved][kved];
      if(vved<1e-99)
      { for(j=N;j--;)
        {  if(~rn[j]) for(k=N;k--;)
                m[j][k]=_indefinite;
           if(~cn[j]) for(k=N;k--;)
                m[k][j]=_indefinite;
        }
        return;
      }
      int jt=rn[jved],kt=cn[kved];
      for(j=N;j--;)
        t=m[kt][j],m[kt][j]=m[jved][j],m[jved][j]=t;
      for(j=N;j--;)
        t=m[j][jt],m[j][jt]=m[j][kved],m[j][kved]=t;

      rn[jved]=rn[kt];
      cn[kved]=cn[jt];
      rn[kt]=cn[jt]=-1;

      vved=m[kt][jt];   m[kt][jt]=1;
      for(j=N;j--;)
      {  if(j==kt)
           continue;
         double mul=m[j][jt]/vved;
         m[j][jt]=0;
         for(k=N;k--;)
           m[j][k]-=m[kt][k]*mul;
      }
      for(k=N;k--;)
        m[kt][k]/=vved;
   }
   #undef N
 }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#if 0
#define RAZM 4
#define razm RAZM
typedef double MR[RAZM][RAZM]; typedef double VR[RAZM];
void matmat(MR, MR,MR);void matvec(VR, MR ,VR);
typedef double M2[2][2];void matmat(M2, M2,M2);
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
static unsigned long rand_mul=1333555777uL;
double drand()
 {
    static unsigned long l17,l13,l3;
    static unsigned long m1=1;

    __emit__(0x66);
    asm ror word ptr l17,17;
    __emit__(0x66);
    asm ror word ptr l13,13;
    __emit__(0x66);
    asm ror word ptr l3,3;
    return (((l17+=0x076542eb)+(l13+=0x064242b5)+(l3+=0xACE542CB)^(m1*=rand_mul))&0x7FFFFFFFL)*(1/(float(0x7FFFFFFFL)+1));
 }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mem.h>
void mk_diag(double m[RAZM][RAZM])
 { for(int j=0;j<RAZM;j++) for(int k=j+1;k<RAZM;k++)
     m[j][k]=m[k][j]=(m[j][k]+m[k][j])/2;
 }
void trans(double t[RAZM][RAZM],double m[RAZM][RAZM])
 { for(int j=0;j<RAZM;j++) for(int k=0;k<RAZM;k++)
     t[j][k]=m[k][j];
 }
double form(double m[RAZM][RAZM],double a[],double *b=0)
 { double c[RAZM],r;
   matvec(c,m,b?b:a);
   for(int j=r=0;j<RAZM;j++)
     r+=c[j]*a[j];
   return r;
 }
/*
void randomMat(double mat[RAZM][RAZM])
 { int s,k;
   for(s=0;s<RAZM;s++) for(k=0;k<RAZM;k++)
      mat[s][k]=rand()+sin(k*s+.3*s*s)*.02-.3*RAND_MAX;
 }
void randomVec(double vec[RAZM])
 {  for(int k=0;k<RAZM;k++)
      vec[k]=rand()+sin(k+.7*k*k)*.03;
 }
void xuux()
  { double matr[RAZM][RAZM],m[RAZM][RAZM],mm[RAZM][RAZM],vec[RAZM],rez[RAZM],test[RAZM],t[RAZM],v[RAZM];
   randomMat(matr); randomVec(vec); randomVec(test);
   //sv();
   _AX=__LINE__;
   // memcpy(matr[3], matr[5],sizeof(*matr));
   // memcpy(matr[4], matr[5],sizeof(*matr));
   //ttt(m,mm);

   gaus(t, matr,test);
   matvec(test, matr, t);
   matvec(test, matr, t);
 }
*/
void main()
 { MR ma,mb,mib,mc;
   VR va,vb,vc,vd;
   double a,b,c;
   int j,k;
   for(j=RAZM*RAZM;j--;)
    ma[0][j]=int(1000*drand()-500)/1000., mb[0][j]=int(1000*drand()-500)/1000., mb[0][j]=int(1000*drand()-500)/1000.;
   for(j=RAZM;j--;)
    va[j]=.5*drand()-.25, vb[j]=.5*drand()-.25, vb[j]=.5*drand()-.25;
   for(j=RAZM;j--;)
    ma[j][j]+=1.5, mb[j][j]+=1.5, mc[j][j]+=1.5;
    mk_diag(ma);
    a=form(ma,va);
    memcpy(mib,mb,sizeof(MR));  invers(mib);
    matvec(vc, mib,va);
    a=form(ma,vb,vc);
    matmat(mc,ma,mib);
    a=form(mc,vb,va);

    matvec(vd,mib,va);
    matvec(vd,ma,vd);

    matmat(mib,ma,mib);
    matvec(vd,mib,va);


    matmat(mc,ma,mb);
    trans(mib,mb);
    //memcpy(mib,mb,sizeof(MR));
    matmat(mc,mib,mc);
    a=form(mc,vc);
    _AX=__LINE__;

 }
#endif
